<?php
/****************************************************************************
 *                                                                          *
 *                         P A B [PHPAntiBot]                               *
 *                                                                          *
 * Copyright (C) 2006-2007 Jonathan BURON <webmaster@natsimhan.com>         *
 *                                                                          *
 * This file is part of PAB                                                 *
 *                                                                          *
 * PHPAntiBot is free software; you can redistribute it and/or modify       *
 * it under the terms of the GNU General Public License as published by     *
 * the Free Software Foundation; either version 2 of the License.           *
 *                                                                          *
 * PHPAntiBot is distributed in the hope that it will be useful,            *
 * but WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the             *
 * GNU General Public License for more details.                             *
 *                                                                          *
 * You should have received a copy of the GNU General Public License        *
 * along with PHPAntiBot; if not, write to the Free Software                *
 * Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA 02110-1301 USA *
 ****************************************************************************/


if(!defined('__CLASS_INSTALL_PHP__')):
define('__CLASS_INSTALL_PHP__',true);

  # Cette classe s'occupe de l'installation du script PHPAntiBot sur le serveur
  # Elle va générer les fichiers nécessaires après avoir questionné l'administrateur
  class Install {

    public $_filePK = '../pk/.pk';
    
    private $_maxLinePK = 1000;
    private $_maxCharPrivateKey = 8;

    # Constructeur de la classe
    function __construct() {
      $this->_filePK = dirname(__FILE__).'/../pk/.pk';
  	}

    # Démarre l'installation
    public function startInstallation(){
      echo "G&eacute;n&eacute;ration du fichier :<br />";
      # on génère le fichier des clefs
      $this->genPK();
      # on dit que tout c'est bien passé
      echo "G&eacute;n&eacute;ration r&eacute;ussie !<br />";
    }
    
    # Renvoi true si l'installation est faite non sinon...
    public function isCompleted(){
      # on vérfie l'existance du fichier .pk contenant les couples public/privé
      if(is_file($this->_filePK)){
        return true;
      }else{
        return false;
      }
    }  	
    
    # génération du fichier et de ses couples de clefs public/privé
    private function genPK(){
      # création du fichier en écriture
      if(!$fd = fopen ($this->_filePK, "w")) {
        echo "Impossible de cr&eacute;er le fichier <b>".$this->_filePK."</b><br />"
            ."Vous devez mettre les droits en &eacute;criture sur le dossier pab/pk/";
        exit;
      }else{
        # Ecriture du fichier ligne après ligne
        $cpt = 0;
        do{
          $public = $this->genPublickey();
          $private = $this->genPrivatekey();
          $new_line = '|'.$public.'|'.$private.'|'."\n";
        }while($cpt++<$this->_maxLinePK && ($write_ok=fwrite($fd, $new_line))!==false);

        if($write_ok === false){
           echo "Impossible d'&eacute;crire dans le fichier (".$this->_filePK.")<br />"
               ."Vous devez mettre les droits en &eacute;criture sur le dossier pab/pk/";
           exit;
        }
        # Fermeture du fichier
        fclose($fd);
      }
    }

    private function genPublickey(){
  		$key='';
  		$aleatoire='aUKtuBGHIxyET6oVjkJPdeZ1CmpQz5bv34DfghF2AsqrWXn0LMN7lciwRSYO';
  		$ln_aleatoire=strlen($aleatoire)-1;

  		for($i=0;$i<64;$i++){
  			$key .= $aleatoire[rand(0,$ln_aleatoire)];
  		}

  		return $key;
    }

    private function genPrivatekey(){
  		$key='';
  		$aleatoire='ABCDFGHJKLMNPQRSTUVWXY34589';
  		$ln_aleatoire=strlen($aleatoire)-1;

  		for($i=0;$i<$this->_maxCharPrivateKey;$i++){
  			$key .= $aleatoire[rand(0,$ln_aleatoire)];
  		}

  		return $key;
    }

  }
endif;# __CLASS_INSTALL_PHP__
?>
